'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _findNeighbors = require('./findNeighbors');

var _findNeighbors2 = _interopRequireDefault(_findNeighbors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (cells, width, height) {
  var initEmptyBoard = function initEmptyBoard(width, height) {
    var board = [];
    for (var i = 0; i < width * height; ++i) {
      board[i] = false;
    }
    return board;
  };

  var board = initEmptyBoard(width, height);
  cells.forEach(function (isAlive, i) {
    var neighborIndexes = (0, _findNeighbors2.default)(i, width, height);
    var neighborStatuses = neighborIndexes.map(function (ni) {
      return cells[ni];
    });
    var aliveNeighbors = neighborStatuses.filter(function (e) {
      return e;
    }).length;

    // rules
    if (!isAlive && aliveNeighbors === 3) {
      board[i] = true;
    } else if (isAlive && (aliveNeighbors === 2 || aliveNeighbors === 3)) {
      board[i] = true;
    } else if (isAlive && aliveNeighbors < 2) {
      board[i] = false;
    } else if (isAlive && aliveNeighbors > 3) {
      board[i] = false;
    }
  });

  return board;
};