"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (index, width, height) {
  var wrapRow = function wrapRow(value) {
    var m = width * height;
    return (value + m) % (width * height);
  };

  var findNeighbor1 = function findNeighbor1(index) {
    var isLeftmost = index % width === 0;
    var compensation = 0;
    if (isLeftmost) {
      compensation = width;
    }

    var value = index - width - 1;
    return wrapRow(value + compensation);
  };

  var findNeighbor2 = function findNeighbor2(index) {
    var value = index - width;
    return wrapRow(value);
  };

  var findNeighbor3 = function findNeighbor3(index) {
    var isRightmost = index % width === width - 1;
    var compensation = 0;
    if (isRightmost) {
      compensation = width;
    }

    var value = index - width + 1;
    return wrapRow(value - compensation);
  };

  var findNeighbor4 = function findNeighbor4(index) {
    var isLeftmost = index % width === 0;
    var compensation = 0;
    if (isLeftmost) {
      compensation = width;
    }
    return index - 1 + compensation;
  };

  var findNeighbor5 = function findNeighbor5(index) {
    var isRightmost = index % width === width - 1;
    var compensation = 0;
    if (isRightmost) {
      compensation = width;
    }
    return index + 1 - compensation;
  };

  var findNeighbor6 = function findNeighbor6(index) {
    var isLeftmost = index % width === 0;
    var compensation = 0;
    if (isLeftmost) {
      compensation = width;
    }

    var value = index + width - 1;
    return wrapRow(value + compensation);
  };

  var findNeighbor7 = function findNeighbor7(index) {
    var value = index + width;
    return wrapRow(value);
  };

  var findNeighbor8 = function findNeighbor8(index) {
    var isRightmost = index % width === width - 1;
    var compensation = 0;
    if (isRightmost) {
      compensation = width;
    }
    var value = index + width + 1;
    return wrapRow(value - compensation);
  };

  var findNeighbors = function findNeighbors(index) {
    return [findNeighbor1(index), findNeighbor2(index), findNeighbor3(index), findNeighbor4(index), findNeighbor5(index), findNeighbor6(index), findNeighbor7(index), findNeighbor8(index)];
  };

  return findNeighbors(index);
};